"use strict";

var _interopRequireDefault = require("@babel/runtime-corejs2/helpers/interopRequireDefault");

var _promise = _interopRequireDefault(require("@babel/runtime-corejs2/core-js/promise"));

module.exports = function deferred() {
  var resolve, reject, resolved;
  return {
    get resolve() {
      return resolve;
    },

    get reject() {
      return reject;
    },

    get resolved() {
      return resolved;
    },

    promise: new _promise.default(function (_resolve, _reject) {
      resolve = function resolve() {
        if (!resolved) {
          resolved = true;
          return _resolve.apply(this, arguments);
        }
      };

      reject = function reject() {
        if (!resolved) {
          resolved = true;
          return _reject.apply(this, arguments);
        }
      };
    })
  };
};