"use strict";

module.exports = function (assetsByChunkName) {
  assetsByChunkName.main = assetsByChunkName.main instanceof Array ? assetsByChunkName.main : [assetsByChunkName.main];
  assetsByChunkName.vendor = assetsByChunkName.vendor instanceof Array ? assetsByChunkName.vendor : [assetsByChunkName.vendor];
  var bundle = {
    js: {
      main: "/assets/".concat(assetsByChunkName.main.find(function (fileName) {
        return /\.main\.js$/gi.test(fileName);
      })),
      vendor: "/assets/".concat(assetsByChunkName.vendor.find(function (fileName) {
        return /\.vendor\.js$/gi.test(fileName);
      }))
    },
    css: {
      main: "/assets/".concat(assetsByChunkName.main.find(function (fileName) {
        return /\.main\.css$/gi.test(fileName);
      }))
    }
  };
  global.frontful = global.frontful || {};
  global.frontful.environment = global.frontful.environment || {};
  global.frontful.environment.bundle = bundle;
};