"use strict";

var _interopRequireDefault = require("@babel/runtime-corejs2/helpers/interopRequireDefault");

var _stringify = _interopRequireDefault(require("@babel/runtime-corejs2/core-js/json/stringify"));

var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime-corejs2/helpers/classCallCheck"));

var _createClass2 = _interopRequireDefault(require("@babel/runtime-corejs2/helpers/createClass"));

var Coldreload;

if (process.env.NODE_ENV !== 'production') {
  var _temp;

  var socketio = require('socket.io-client');

  Coldreload = (_temp =
  /*#__PURE__*/
  function () {
    function Coldreload() {
      var _this = this;

      (0, _classCallCheck2.default)(this, Coldreload);
      this.serializer = null;
      this.socket = socketio('/', {
        path: '/frontful-coldreload'
      });
      this.socket.on('connect', function () {
        _this.log('Server connected');
      });
      this.socket.on('frontful.coldreload.reload', function () {
        if (_this.serializer) {
          var data = _this.serializer();

          localStorage.setItem('frontful.coldreload.state', (0, _stringify.default)(data));

          _this.socket.emit('frontful.coldreload.state', data, function () {
            window.location.reload();
          });

          _this.log('State stored and serialize');
        } else {
          window.location.reload();
        }
      });
    }

    (0, _createClass2.default)(Coldreload, [{
      key: "deserialize",
      value: function deserialize() {
        var strData = localStorage.getItem('frontful.coldreload.state');
        localStorage.setItem('frontful.coldreload.state', '');
        var data = strData ? JSON.parse(strData) : null;

        if (data) {
          this.deserializer(data);
          this.log('State restored and deserialized');
        }
      }
    }, {
      key: "log",
      value: function log(text) {
        console.log("%c".concat(text), 'color: gray;');
      }
    }, {
      key: "deserializer",
      get: function get() {
        return this._deserializer;
      },
      set: function set(deserializer) {
        this._deserializer = deserializer;
        this.deserialize();
      }
    }]);
    return Coldreload;
  }(), _temp);
} else {
  Coldreload =
  /*#__PURE__*/
  function () {
    function Coldreload() {
      (0, _classCallCheck2.default)(this, Coldreload);
    }

    (0, _createClass2.default)(Coldreload, [{
      key: "deserialize",
      value: function deserialize() {}
    }, {
      key: "log",
      value: function log() {}
    }]);
    return Coldreload;
  }();
}

window.frontful = window.frontful || {};
window.frontful.environment = window.frontful.environment || {};
window.frontful.environment.coldreload = new Coldreload();