"use strict";

var _interopRequireDefault = require("@babel/runtime-corejs2/helpers/interopRequireDefault");

var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime-corejs2/helpers/classCallCheck"));

var _createClass2 = _interopRequireDefault(require("@babel/runtime-corejs2/helpers/createClass"));

var Coldreload;

if (process.env.NODE_ENV !== 'production') {
  var socketio = require('socket.io');

  var chalk = require('chalk');

  Coldreload =
  /*#__PURE__*/
  function () {
    function Coldreload() {
      (0, _classCallCheck2.default)(this, Coldreload);
    }

    (0, _createClass2.default)(Coldreload, [{
      key: "start",
      value: function start(server) {
        var _this = this;

        this.socket = socketio(server, {
          path: '/frontful-coldreload'
        });
        this.socket.on('connection', function (browser) {
          _this.log('Browser connected');

          browser.on('frontful.coldreload.state', function (state, ack) {
            _this.state = state;
            ack(true);
          });
        });
      }
    }, {
      key: "reload",
      value: function reload() {
        this.socket.emit('frontful.coldreload.reload', null, {
          for: 'everyone'
        });
      }
    }, {
      key: "log",
      value: function log() {
        console.log(chalk.gray.apply(chalk, arguments));
      }
    }, {
      key: "state",
      get: function get() {
        var _this2 = this;

        process.nextTick(function () {
          _this2._state = null;
        });
        return this._state;
      },
      set: function set(state) {
        this._state = state;
      }
    }]);
    return Coldreload;
  }();
} else {
  Coldreload =
  /*#__PURE__*/
  function () {
    function Coldreload() {
      (0, _classCallCheck2.default)(this, Coldreload);
    }

    (0, _createClass2.default)(Coldreload, [{
      key: "start",
      value: function start() {}
    }, {
      key: "reload",
      value: function reload() {}
    }, {
      key: "log",
      value: function log() {}
    }, {
      key: "state",
      get: function get() {
        return null;
      }
    }]);
    return Coldreload;
  }();
}

global.frontful = global.frontful || {};
global.frontful.environment = global.frontful.environment || {};
global.frontful.environment.coldreload = new Coldreload();